<?php

namespace Espo\Modules\RealEstate\Controllers;

use \Espo\Core\Exceptions\Forbidden;
use \Espo\Core\Exceptions\BadRequest;
use \Espo\Core\Exceptions\NotFound;

class RealEstateMatchingConfiguration extends \Espo\Core\Controllers\Base
{
    protected function checkControllerAccess()
    {
        if (!$this->getUser()->isAdmin()) {
            throw new Forbidden();
        }
    }

    public function putActionUpdate($params, $data, $request)
    {
        $this->getServiceFactory()->create('RealEstateMatchingConfiguration')->setMatchingParameters($data);

        $this->getContainer()->get('dataManager')->rebuild();

        return true;
    }
}
